#version 430 core                                                                               
                                                                                                
// define the number of CPs in the output patch                                                 
layout (vertices = 3) out;                                                                      
                                                                                                
uniform vec3 camera_world;                                                                      
                                                                                          

in vec3 position_world_CS[];
in vec3 normal_world_CS[];
in vec2 uv_CS[];                                                                   
                                                                                                
out vec3 position_world_ES[];                                                                      
out vec2 uv_ES[];                                                                      
out vec3 normal_world_ES[];                                                                        
                                                                                                
float GenerateTesselationLevel(float d1, float d2)                                            
{                                                                                               
    float meanDis = (d1 + d2) / 2.0;                                          
	
    if (meanDis <= 50.0) {                                                                   
        return 30.0;                                                                            
    }                                                                                           
    else if (meanDis <= 100.0) {                                                              
        return 15.0;                                                                             
    }                                                                                           
    else {                                                                                      
        return 5.0;                                                                             
    }                                                                                           
}                                                                                               
                                                                                                
void main()                                                                                     
{                                                                                                                                           
    uv_ES[gl_InvocationID] = uv_CS[gl_InvocationID];                          
    normal_world_ES[gl_InvocationID]   = normal_world_CS[gl_InvocationID];                            
    position_world_ES[gl_InvocationID] = position_world_CS[gl_InvocationID];                          
                                                                                                                      
    float distanceToCorner0 = distance(camera_world, position_world_ES[0]);                     
    float distanceToCorner1 = distance(camera_world, position_world_ES[1]);                     
    float distanceToCorner2 = distance(camera_world, position_world_ES[2]);                     
                                                                                                                                                       
    gl_TessLevelOuter[0] = GenerateTesselationLevel(distanceToCorner1, distanceToCorner2);            
    gl_TessLevelOuter[1] = GenerateTesselationLevel(distanceToCorner2, distanceToCorner0);            
    gl_TessLevelOuter[2] = GenerateTesselationLevel(distanceToCorner0, distanceToCorner1);            
    gl_TessLevelInner[0] = gl_TessLevelOuter[2];       


}                                                                                               