#version 430 core                                                                               
                                                                                                
layout(triangles, equal_spacing, ccw) in;                                                       


uniform mat4 viewProjMatrix;                                                                              
uniform float textureDipsFactor;  
uniform sampler2D textureDisplacementMap;
                                                                    
                                                                                                
in vec3 position_world_ES[];                                                                       
in vec2 uv_ES[];                                                                       
in vec3 normal_world_ES[];                                                                     
                                                                                                
out VertexData {
	vec3 position_world;
	vec3 normal_world;
	vec2 uv;
} vert;                                                                        
                                                                                                
vec2 generate2DInterpol(vec2 v0, vec2 v1, vec2 v2)                                                   
{                                                                                               
    return vec2(gl_TessCoord.x) * v0 + vec2(gl_TessCoord.y) * v1 + vec2(gl_TessCoord.z) * v2;   
}                                                                                               
                                                                                                
vec3 generate3DInterpol(vec3 v0, vec3 v1, vec3 v2)                                                   
{                                                                                               
    return vec3(gl_TessCoord.x) * v0 + vec3(gl_TessCoord.y) * v1 + vec3(gl_TessCoord.z) * v2;   
}                                                                                               
                                                                                                
void main()                                                                                     
{                                                                                               
    vert.uv = generate2DInterpol(uv_ES[0], uv_ES[1], uv_ES[2]);    
    vert.normal_world = generate3DInterpol(normal_world_ES[0], normal_world_ES[1], normal_world_ES[2]);            
    vert.normal_world = normalize(vert.normal_world);                                                     
    vert.position_world = generate3DInterpol(position_world_ES[0], position_world_ES[1], position_world_ES[2]);   

   	vec3 texColor = texture(textureDisplacementMap, vert.uv).rgb;	
    float Displacement = texColor.x +texColor.y+texColor.z;  	
    vert.position_world -= vert.normal_world * textureDipsFactor;                                                                                    
    vert.position_world += vert.normal_world * (texColor.x * textureDipsFactor);                                
    gl_Position = viewProjMatrix*vec4(vert.position_world, 1.0);                                              
}                                                                                               
